#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <string.h>
#include <errno.h>
#include "mn_pppst.h"

/* Prototype declaration */
static void write_ppp_file(int status, int session, unsigned long gwaddr) ;

void mn_pppst_connect(int session, unsigned long gwaddr)
{
    write_ppp_file(PPPST_STATUS_CONNECT, session, gwaddr) ;

    return ;
}

void mn_pppst_disconnect(int session)
{
    write_ppp_file(PPPST_STATUS_DISCONNECT, session, 0) ;
}

static void write_ppp_file(int status, int session, unsigned long gwaddr)
{
#define PPPST_PPP_FILE                  "/proc/net/ppp%d"
#define PPPST_PPP_FILE_LEN_MAX          (sizeof("/proc/net/pppXX") + 1)
#define PPPST_CMD_FMT                   "echo %d %08x > %s"
#define PPPST_CMD_LEN_MAX               (sizeof("echo x xxxxxxxx > /proc/net/pppXX") + 1)
#define PPPST_PPP_VAR_FILE              "/var/run/ppp%d"
#define PPPST_PPP_VAR_FILE_LEN_MAX      (sizeof("/var/run/pppXX") + 1)

    FILE                *f ;
    char                path[PPPST_PPP_FILE_LEN_MAX] ;
    char                path2[PPPST_PPP_VAR_FILE_LEN_MAX] ;
    char                cmd[PPPST_CMD_LEN_MAX] ;
    int                 ret ;
    int                 data ;

    /* for kernel */
    sprintf(path, PPPST_PPP_FILE, session) ;
    sprintf(cmd, PPPST_CMD_FMT, status, htonl(gwaddr), path) ;
    ret = system(cmd) ;

    /* for DNS */
    sprintf(path2, PPPST_PPP_VAR_FILE, session) ;
    f = fopen(path2, "w") ;
    if (!f)
    {
        fprintf(stderr, "pppst: write_ppp_file() fopen NG. errno=%d\n", errno) ;
	return ;
    }

    data = status + '0' ;
    if (fputc(data, f) != data)
    {
        fprintf(stderr, "pppst: write_ppp_file() fputc NG. errno=%d\n", errno) ;
    }
    fclose(f) ;

    return ;
}
