#ifndef _IP_CONNTRACK_MSNP_H
#define _IP_CONNTRACK_MSNP_H
/* MSNP tracking. */

#ifndef __KERNEL__
#error Only in kernel.
#endif

#include <linux/netfilter_ipv4/lockhelp.h>

/* Protects msnp part of conntracks */
DECLARE_LOCK_EXTERN(ip_msnp_lock);

/* MSNP Data. This struct for Messenger 5.0 */
struct ip_ct_msnp_data
{
	/* IP-Address */
	u_int32_t	ip;
	/* IP-Address-Internal */
	u_int32_t	ip_internal;
	/* PortX-Internal (maybe unused)*/
	u_int16_t	portX_internal;
	/* Port */
	u_int16_t	port;
	/* PortX */
	u_int16_t	portX;
};

/* We record seq number and length of msnp ip/port text here: all in
   host order. */
struct ip_ct_msnp
{
	/* This tells NAT that this is an msnp connection */
	int is_msnp;
	u_int32_t seq;
	/* 0 means not found yet */
	u_int32_t len;
	/* Port that was to be used */
	u_int16_t port;
	/* Next valid seq position for cmd matching after newline */
	u_int32_t seq_aft_nl[IP_CT_DIR_MAX];
	/* 0 means seq_match_aft_nl not set */
	int seq_aft_nl_set[IP_CT_DIR_MAX];
	/* version */
	int version;
	/* data of msnp packet */
	struct ip_ct_msnp_data msnp_data;
};


#endif /* _IP_CONNTRACK_MSNP_H */
