/*=======================================================================
; Comment: Java Script for checking Firewall IP Address
; IN : IP Address, Check NULL Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckFirewallIP1(addr, NullCheckFlg)
{
    if(addr.value == "*"){
        return true;
    }else if(addr.value == "BRW101"){
        return true;
    }else{
        if(CheckIPAddress(addr, NullCheckFlg, 0) == false){
            alert("Invalid IP Address ( "+addr.value+" ).");
            addr.value = "";
            return false;
        }else{
            return true;
        }
    }
}

/*=======================================================================
; Comment: Java Script for checking Firewall IP Address
; IN : IP Address, Check NULL Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckFirewallIP2(addr, NullCheckFlg)
{
    if(CheckIPAddress(addr, NullCheckFlg, 0) == false){
        alert("Invalid IP Address ( "+addr.value+" ).");
        addr.value = "";
        return false;
    }else{
        return true;
    }
}

/*=======================================================================
; Comment: Java Script for checking Firewall Port Number
; IN : Port Number, Portocol selection, Error Message Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckFirewallPort1(port, protocol, err_mess)
{
    if(((protocol.value == "5") || (protocol.value == "6") || (protocol.value == "7") || (protocol.value == "8")) && (port.value != "*")){
        port.value="*";
        if(err_mess){
            alert("Invalid Prot Input for ICMP, GRE and EPS Protocol.");
        }else{
            /* do nothing */
        }
        return false;
    }else{
        /* do nothing */
    }
    if(CheckPort(port, 1, 0) == false){
    	alert("Invalid Port Number ( "+port.value+" ).");
    	port.value = "";
    	return false;
    }else{
        /* do nothing */
    }
    return true;
}

/*=======================================================================
; Comment: Java Script for checking Firewall Port Number
; IN : Port Number, Portocol selection, Error Message Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckFirewallPort2(port, protocol, err_mess)
{
    if(port.value == "*"){
        alert("Invalid Port Number ( "+port.value+" ).");
        port.value = "";
        return false;
    }else{
        /* do nothing */
    }
    if(((protocol.value == "5") || (protocol.value == "6") || (protocol.value == "7") || (protocol.value == "8")) && (port.value != "")){
        port.value="";
        if(err_mess){
            alert("Invalid Prot Input for ICMP, GRE and EPS Protocol.");
        }else{
            /* do nothing */
        }
        return false;
    }else{
        /* do nothing */
    }
    if(CheckPort(port, 0, 0) == false){
        alert("Invalid Port Number ( "+port.value+" ).");
        port.value = "";
        return false;
    }else{
        /* do nothing */
    }
    return true;
}

/*=======================================================================
; Comment: Java Script for checking Firewall Protocol
; IN : Form Type
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/10
; Original Reference: KME project
;========================================================================*/
function CheckFirewallProto(form)
{
    if((form.protocol.value == "5") || (form.protocol.value == "6") || (form.protocol.value == "7") || (form.protocol.value == "8")){
        form.sport1.value = "*";
        form.sport2.value = "";
        form.dport1.value = "*";
        form.dport2.value = "";
    }else{
        /* do nothing */
    }
}

/*=======================================================================
; Comment: Java Script for checking IP2 > IP1
; IN : IP Address 1, IP Address 2
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckIpOrder(ip1, ip2)
{
    var ip1_str = Trim(ip1);
    var ip2_str = Trim(ip2);
    
    if(ip1_str == "" || ip2_str == ""){
        return false;
    }else{
        /* do nothing */
    }
    
    ip1_strArray=new Array(4);
    ip1_strArray=ip1_str.split(".");
    ip2_strArray=new Array(4);
    ip2_strArray=ip2_str.split(".");
    
    for(var i=0; i<4; i++){
        if( eval(ip2_strArray[i]) < eval(ip1_strArray[i]) ){
            return false;
        }else if( eval(ip2_strArray[i]) > eval(ip1_strArray[i]) ){
            return true;
        }
    }
    return true;
}

/*=======================================================================
; Comment: Java Script for checking Port2 > Port1
; IN : Port Number 1, Port Number 2
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckPortOrder(port1, port2)
{
    var port1_str = Trim(port1);
    var port2_str = Trim(port2);
    
    if(port1_str == "" || port2_str == ""){
        return false;
    }else{
        /* do nothing */
    }
    
    var flag=isNaN(port1_str);
    if(flag==true){
        return false;
    }else{
        /* do nothing */
    }
    flag=isNaN(port2_str);
    if(flag==true){
        return false;
    }else{
        /* do nothing */
    }
    
    if( eval(port2_str) > eval(port1_str) ){
        return true;
    }else{
        return false;
    }
}

/*=======================================================================
; Comment: Java Script for checking Firewall Rule
; IN : Form Type
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckFirewallRule(form)
{
    var flag = 0;
    if(form.rule_no.value.match(/\D/) || (form.rule_no.value < 1 || form.rule_no.value > 64)){
        alert("Invalid Firewall Rule Number ( "+form.rule_no.value+" ).");
        form.rule_no.value = "";
        return false;
    }else{
        /* do nothing */
    }
    if(form.direction[1].selected==true && form.saddr1.value.match(/^BRW101?/)){
        alert("Invalid Input in Sender IP Address ( "+form.saddr1.value+" ).");
        form.saddr1.value = "";
        return false;
    }else{
        /* do nothing */
    }
    if(!(form.saddr1.value.charAt(0) == "*" && form.saddr1.value.length == 1) && !form.saddr1.value.match(/^BRW101?/)){
        if(!CheckIPAddress(form.saddr1, 1, 0)){
            alert("Invalid Input in Sender IP Address ( "+form.saddr1.value+" ).");
            form.saddr1.value = "";
            return false;
        }else if(CheckIPAddress(form.saddr2, 0, 0) == false){
            alert("Invalid Input in Sender IP Address ( "+form.saddr2.value+" ).");
            form.saddr2.value = "";
            return false;
        }else{
            /* do nothing */
        }
        if(Trim(form.saddr2.value) != ""){
            if(CheckIpOrder(form.saddr1.value, form.saddr2.value) == false){
                alert("Invalid Both Sender IP Address Order.");
                form.saddr2.value = "";
                return false;
            }else{
                /* do nothing */
            }
        }else{
            /* do nothing */
        }
    }else{
        if(Trim(form.saddr2.value) != ""){
            alert("Sender IP Address is * or BRW101.");
            form.saddr2.value = "";
        }else{
            /* do nothing */
        }
    }
    if(!(form.sport1.value.charAt(0) == "*" && form.sport1.value.length == 1)){
        if(CheckPort(form.sport1, 1, 0) == false){
            alert("Invalid Input in Sender Port Number ( "+form.sport1.value+" ).");
            form.sport1.value = "";
            return false;
        }else{
            /* do nothing */
        }
        if(CheckPort(form.sport2, 0, 0) == false){
            alert("Invalid Input in Sender Port Number ( "+form.sport2.value+" ).");
            form.sport2.value = "";
            return false;;
        }else{
            /* do nothing */
        }
        if(Trim(form.sport2.value) != ""){
            if(CheckPortOrder(form.sport1.value, form.sport2.value) == false){
                alert("Invalid Both Sender IP Address Order.");
                form.sport2.value = "";
                return false;
            }else{
                /* do nothing */
            }
        }else{
            /* do nothing */
        }
        if(!CheckFirewallPort1(form.sport1, form.protocol, 0)){
            alert("Invalid Prot Input for ICMP, GRE and EPS Protocol.");
        }else{
            /* do nothing */
        }
        if(!CheckFirewallPort2(form.sport2, form.protocol, 0)){
            alert("Invalid Prot Input for ICMP, GRE and EPS Protocol.");
        }else{
            /* do nothing */
        }
    }else{
        if(Trim(form.sport2.value) != ""){
            alert("Sender Port Number is *");
            form.sport2.value = "";
        }else{
            /* do nothing */
        }
    }
    if(form.direction[0].selected==true && form.daddr1.value.match(/^BRW101?/)){
        alert("Invalid Input in Receiver IP Address ( "+form.daddr1.value+" ).");
        form.daddr1.value = "";
        return false;
    }else{
        /* do nothing */
    }
    if(!(form.daddr1.value.charAt(0) == "*" && form.daddr1.value.length == 1) && !form.daddr1.value.match(/^BRW101?/)){
        if(!CheckIPAddress(form.daddr1, 1, 0)){
            alert("Invalid Input in Receiver IP Address ( "+form.daddr1.value+" ).");
            form.daddr1.value = "";
            return false;
        }else if(CheckIPAddress(form.daddr2, 0, 0) == false){
            alert("Invalid Input in Receiver IP Address ( "+form.daddr2.value+" ).");
            form.daddr2.value = "";
            return false;
        }else{
            /* do nothing */
        }
        if(Trim(form.daddr2.value) != ""){
            if(CheckIpOrder(form.daddr1.value, form.daddr2.value) == false){
                alert("Invalid Both Receiver IP Address Order.");
                form.saddr2.value = "";
                return false;
            }else{
                /* do nothing */
            }
        }else{
            /* do nothing */
        }
    }else{
        if(Trim(form.daddr2.value) != ""){
            alert("Receiver IP Address is * or BRW101.");
            form.daddr2.value = "";
        }else{
            /* do nothing */
        }
    }
    if(!(form.dport1.value.charAt(0) == "*" && form.dport1.value.length == 1)){
        if(CheckPort(form.dport1, 1, 0) == false){
            alert("Invalid Input in Sender Port Number ( "+form.dport1.value+" ).");
            form.dport1.value = "";
            return false;
        }else{
            /* do nothing */
        }
        if(CheckPort(form.dport2, 0, 0) == false){
            alert("Invalid Input in Sender Port Number ( "+form.dport2.value+" ).");
            form.dport2.value = "";
            return false;;
        }else{
            /* do nothing */
        }
        if(Trim(form.dport2.value) != ""){
            if(CheckPortOrder(form.dport1.value, form.dport2.value) == false){
                alert("Invalid Both Sender IP Address Order.");
                form.dport2.value = "";
                return false;
            }else{
                /* do nothing */
            }
        }else{
            /* do nothing */
        }
        if(!CheckFirewallPort1(form.dport1, form.protocol, 0)){
            alert("Invalid Prot Input for ICMP, GRE and EPS Protocol.");
        }else{
            /* do nothing */
        }
        if(!CheckFirewallPort2(form.dport2, form.protocol, 0)){
            alert("Invalid Prot Input for ICMP, GRE and EPS Protocol.");
        }else{
            /* do nothing */
        }
    }else{
        if(Trim(form.dport2.value) != ""){
            alert("Sender Port Number is *");
            form.dport2.value = "";
        }else{
            /* do nothing */
        }
    }
    if(form.protocol[0].selected == true){
        alert("Please Select Protocol");
        return false;
    }else{
        return true
    }
}

/*=======================================================================
; Comment: Java Script for checking VPN Pass Through
; IN : Form Type
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckVPN(form)
{
    if((form.pptp_pass_through[1].checked == true) && (CheckIPAddress(form.pptp_pass_through_ip, 0, 0) == false)){
        alert("Invalid PPTP Pass Through IP Address ( "+form.pptp_pass_through_ip.value+" ).");
        form.pptp_pass_through_ip.value="";
    }else{
        /* do nothing */
    }
    if((form.ipsec_pass_through[1].checked == true) && (CheckIPAddress(form.ipsec_pass_through_ip, 0, 0) == false)){
        alert("Invalid IPSec Pass Through IP Address ( "+form.ipsec_pass_through_ip.value+" ).");
        form.ipsec_pass_through_ip.value="";
    }else{
        /* do nothing */
    }
    if((form.l2tp_pass_through[1].checked == true) && (CheckIPAddress(form.l2tp_pass_through_ip, 0, 0) == false)){
        alert("Invalid L2TP Pass Through IP Address ( "+form.l2tp_pass_through_ip.value+" ).");
        form.l2tp_pass_through_ip.value="";
    }else{
        /* do nothing */
    }
}
