/*=======================================================================
; Comment: Java Script for checking IP Address
; IN : Data String, Check NULL Flag, Error Message Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/01
; Original Reference: KME project
;========================================================================*/
function CheckIPAddress(ip, NullCheckFlg, err_mess)
{
    var ip_value = ip.value;
    var flag = true;
    
    if( NullCheckFlg == 0 ){
        if(Trim(ip_value) == ""){
            ip.value="";
            return true;
        }else{
            /* do nothing */
        }
    }
    
    if(ip_value.match(/^((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.){3}(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/)){
        if(ip_value.match(/^0\.0\.0\.0$/) || ip_value.match(/^255\.255\.255\.255$/)){
    	    flag = false;
    	}else{
    	    /* do nohing */
    	}
    }else{
        flag = false;
    }
    
    if(!flag){
        if(err_mess){
            alert("Invalid IP Address ( "+ip_value+" ).");
            ip.value="";
        }else{
            /* do nothing */
        }
    }else{
        /* do nothing */
    }
    return flag;
}

/*=======================================================================
; Comment: Java Script for checking Netmask Address
; IN : Data String, Check NULL Flag, Error Message Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/01
; Original Reference: KME project
;========================================================================*/
function CheckNetmask(ip, NullCheckFlg, err_mess)
{
    var pointadd1 = 0;
    var pointadd2 = 0;
    var pointno = 0;
    var ip_value2;
    var ip_value = new Array();
    var flag = 0;
    var ipa = "";
    var ipb = "";
    var ipc = "";
    var ipd = "";
    
    ip_value[0] = ip.value;
    if(NullCheckFlg == 0){
        if(Trim(ip_value[0]) == ""){
            ip.value="";
            return true;
        }else{
            /* do nothing */
        }
    }
    
    for(var j=0; j<1; j++){
        pointadd1 = 0;
        pointadd2 = 0;
        pointno = 0;
        for(var i=0; i<ip_value[j].length; i++){
            if(ip_value[j].substring(i,i+1)=="."){
                pointno++;
                pointadd2 = i;
                if(ip_value[j].substring(pointadd1,pointadd2)>=0 && ip_value[j].substring(pointadd1,pointadd2)<=255){
                    if(j==0 && pointno==1){
                        ipa=ip_value[j].substring(pointadd1,pointadd2);
                    }else if(j==0 && pointno==2){
                        ipb=ip_value[j].substring(pointadd1,pointadd2);
                    }else if(j==0 && pointno==3){
                        ipc=ip_value[j].substring(pointadd1,pointadd2);
                    }else{
                        /* do nothing */
                    }
                }else{
                    flag = "error";
                }
                pointadd1 = pointadd2 + 1;
            }else{
                /* do nothing */
            }
        }
        pointadd2 = ip_value[j].length;
        ipd = ip_value[j].substring(pointadd1,pointadd2);
        if(ip_value[j].substring(pointadd1,pointadd2)>=0 && ip_value[j].substring(pointadd1,pointadd2)<=255){
            /* do nothing */
        }else{
            flag="error";
        }
        if(pointno!=3){
            flag = "error";
        }else{
            /* do nothing */
        }
    }
    
    if(Trim(ipa)=="" || Trim(ipb)=="" || Trim(ipc)=="" || Trim(ipd)==""){
        flag="error";
    }else if(CheckNetmaskType(ipa) == false || CheckNetmaskType(ipb) == false || CheckNetmaskType(ipc) == false || CheckNetmaskType(ipd) == false){
        flag = "error";
    }else if(ipa == "0" && ipb == "0" && ipc == "0" && ipd == "0"){
        flag = "error";
    }else if((ipa !="255") && (ipb == "0" && ipc =="0" && ipd =="0")){
        /* do nothing */;
    }else if((ipb !="255") && (ipc =="0" && ipd =="0")){
        /* do nothing */;
    }else if(ipc !="255" && ipd =="0"){
        /* do nothing */;
    }else if(ipd !="255"){
        /* do nothing */;
    }else{
        flag ="error";
    }
    
    if(flag=="error"){
        if(err_mess){
            alert("Invalid Netmask Address ( "+ip_value[0]+" ).");
            ip.value = "";
    	}else{
    	    /* do nothing */
    	}
    	return false;
    }else{
        /* do nothng*/
    }
    return true;
}

/*=======================================================================
; Comment: Java Script for checking MAC Address
; IN : Data String, Check NULL Flag, Error Message Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/03
; Original Reference: KME project
;========================================================================*/
function CheckMAC(mac, NullCheckFlg, err_mess)
{
    var flag;
    var mac_value = mac.value;
    
    if(NullCheckFlg == 0 && Trim(mac_value) == ""){
        mac.value="";
        return true;
    }else{
        /* do nothing */
    }
    
    if(mac_value.match(/^(00\:){5}00$/) || mac_value.match(/^([fF]{2}\:){5}[fF]{2}$/)){
        if(err_mess){
            alert("Invalid MAC Address ( "+mac_value+" ).");
        }else{
            /* do nothing */
        }
        mac.value="";
        return false;
    }else{
        /* do nothing */
    }
    if(mac_value.match(/^([A-Fa-f0-9]{2}\:){5}[A-Fa-f0-9]{2}$/)){
        flag = true;
    }else{
        flag = false;
        if(err_mess){
            alert("Invalid MAC Address ( "+mac_value+" ).");
            mac.value="";
        }else{
            /* do nothing */
        }
    }
    
    return flag;
}

/*=======================================================================
; Comment: Java Script for return subnet bit
; IN : IP Address
; OUT: true:subnet bit number, false:0
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/03
; Original Reference: KME project
;========================================================================*/
function ReturnSubnetBit(ipaddr)
{
    var ip_str = ipaddr.value;
    
    if(ip_str.match(/ /i)!=null){
        return 0;
    }else{
        /* do nothing */
    }
    if(ip_str==""){
        return 0;
    }else{
        /* do nothing */
    }
    
    ip_strObj=new String(ip_str);
    ip_strArray=new Array();
    ip_strArray=ip_strObj.split(".");
    
    if(ip_strArray.length!=4){
        return 0;
    }
    
    subnet_bits = 0;
    for(i=0;i<4;i++){
        flag=isNaN(ip_strArray[i]);
        if(flag==true){
            return 0;
        }else{
            /* do nothing */
        }
        if((ip_strArray[i]>255) || (ip_strArray[i]<0)){
            return 0;
        }else{
            /* do nothing */
        }
        if(ip_strArray[i] != 255){
            subnet_bits = (4-i-1)*8;
            if(ip_strArray[i] == 254){
                subnet_bits = subnet_bits+1;
            }else if(ip_strArray[i] == 252){
                subnet_bits = subnet_bits+2;
            }else if(ip_strArray[i] == 248){
                subnet_bits = subnet_bits+3;
            }else if(ip_strArray[i] == 240){
                subnet_bits = subnet_bits+4;
            }else if(ip_strArray[i] == 224){
                subnet_bits = subnet_bits+5;
            }else if(ip_strArray[i] == 192){
                subnet_bits = subnet_bits+6;
            }else if(ip_strArray[i] == 128){
                subnet_bits = subnet_bits+7;
            }else if(ip_strArray[i] == 0){
                subnet_bits = subnet_bits+8;
            }else{
                return 0;
            }
            if(i==3){
                if(ip_strArray[i] == 254){
                    return 0;
                }else{
                    return subnet_bits;
                }
            }
            while(1){
                i=i+1;
                if(ip_strArray[i] != 0){
                    return 0;
                }else{
                    /* do nothing */
                }
                if(i==3){
                    return subnet_bits;
                }else{
                    /* do nothing */
                }
            }
        }else{
            if(i==3){
                return 0;
            }else{
                /* do nothing */
            }
        }
    }
    return 0;
}

/*=======================================================================
; Comment: Java Script for checking IP1 and IP2 is the same subnet
; IN : IP Address 1, IP Address 2, Netmask
; OUT: true:both address is the same, false:both address is not the same
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/03
; Original Reference: KME project
;========================================================================*/
function CheckBothAddrIsSameNet(ipaddr1, ipaddr2, netmask)
{
    var ip1_str = ipaddr1.value;
    var ip2_str = ipaddr2.value;
    var netmask_str = netmask.value;
    
    if(ip1_str.match(/ /i)!=null){
        return false;
    }else{
        /* do nothing */
    }
    if(ip1_str==""){
        return false;
    }else{
        /* do nothing */
    }
    
    if(ip2_str.match(/ /i)!=null){
        return false;
    }else{
        /* do nothing */
    }
    if(ip2_str==""){
        return false;
    }else{
        /* do nothing */
    }
    if(netmask_str.match(/ /i)!=null){
        return false;
    }else{
        /* do nothing */
    }
    if(netmask_str==""){
        return false;
    }else{
        /* do nothing */
    }
    
    var ip1_strObj = new String(ip1_str);
    var ip1_strArray = new Array();
    ip1_strArray = ip1_strObj.split(".");
    if(ip1_strArray.length!=4){
        return false;
    }else{
        /* do nothing */
    }
    
    var ip2_strObj = new String(ip2_str);
    var ip2_strArray = new Array();
    
    ip2_strArray = ip2_strObj.split(".");
    if(ip2_strArray.length!=4){
        return false;
    }else{
        /* do nothing */
    }
    
    var netmask_strObj = new String(netmask_str);
    var netmask_strArray = new Array();
    
    netmask_strArray = netmask_strObj.split(".");
    if(netmask_strArray.length!=4){
        return false;
    }else{
        /* do nothing */
    }
    
    for(var i=0;i<4;i++){
        if((eval(ip1_strArray[i]) & eval(netmask_strArray[i])) != (eval(ip2_strArray[i]) & eval(netmask_strArray[i]))){
            return false;
        }else{
            /* do nothing */
        }
    }
    return true;
}

/*=======================================================================
; Comment: Java Script for checking IP Address is Subnet Address
; IN : IP Address, Netmask Bit
; OUT: true:address is Subset Address, false:address is not Subnet Address
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/03
; Original Reference: KME project
;========================================================================*/
function CheckAddrIsNet(ipaddr, subnet_bits)
{
    var ip_str = ipaddr.value;
    var ip_strObj = new String(ip_str);
    var ip_strArray = new Array();
    
    ip_strArray = ip_strObj.split(".");
    
    var i = 0;
    while (1){
        if(subnet_bits > 8){
            if(eval(ip_strArray[3-i]) != 0){
            	return false;
            }else{
                /* do nothing */
            }
        }else{
            mask = 0;
            while(1){
                mask = (mask << 1) | 1;
                subnet_bits --;
                if(subnet_bits == 0){
                    break;
                }else{
                    /* do nothing */
                }
            }if((eval(ip_strArray[3-i]) & mask) != 0){
                return false;
            }else{
                return true;
            }
        }
        i++;
        subnet_bits = subnet_bits - 8;
    }
    return false;
}

/*=======================================================================
; Comment: Java Script for checking IP Address is Broadcase Address
; IN : IP Address, Netmask Bit
; OUT: true:address is Broadcase Address, false:address is not Broadcase Address
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/03
; Original Reference: KME project
;========================================================================*/
function CheckAddrIsBoard(ipaddr, subnet_bits)
{
    var ip_str = ipaddr.value;
    var ip_strObj = new String(ip_str);
    var ip_strArray = new Array();
    
    ip_strArray = ip_strObj.split(".");
    var i = 0;
    while(1){
        if(subnet_bits > 8){
            if(eval(ip_strArray[3-i]) != 255){
                return false;
            }else{
                /* do nothing */
            }
        }else{
            mask = 0;
            while(1){
                mask = (mask << 1) | 1;
                subnet_bits--;
                if(subnet_bits == 0){
                    break;
                }else{
                    /* do nothing */
                }
            }
            if((eval(ip_strArray[3-i]) & mask) != mask){
                return false;
            }else{
                return true;
            }
        }
        i++;
        subnet_bits = subnet_bits - 8;
    }
    
    return false;
}