/*=======================================================================
; Comment: Java Script for checking DHCP IP Address
           DHCP Start IP and DHCP End IP range is not conflict with Host IP Address
; IN : Host IP Addres, DHCP Start IP Address, DHCP End IP Address
; OUT: true:DHCP IP Address Setting is OK, false:DHCP IP Address Setting is conflict
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/03
; Original Reference: KME project
;========================================================================*/
function CheckDHCPRangeOut(lan_ip, start_ip, end_ip)
{
    var pointadd1=0;
    var pointadd2=0;
    var pointno=0;
    var ip_value= new Array();
    var ipa= new Array();
    var ipb= new Array();
    var ipc= new Array();
    var ipd= new Array();
    
    ip_value[0]=lan_ip.value;
    ip_value[1]=start_ip.value;
    ip_value[2]=end_ip.value;
    
    for(var j=0; j<3; j++){
        pointadd1=0;
        pointadd2=0;
        pointno=0;
        for(var i=0; i<ip_value[j].length; i++){
            if(ip_value[j].substring(i,i+1)=="."){
            	pointno++;
            	pointadd2=i;
            	if(ip_value[j].substring(pointadd1,pointadd2)>=0 && ip_value[j].substring(pointadd1,pointadd2)<=255){
            	    if( pointno==1){
            	        ipa[j]=ip_value[j].substring(pointadd1,pointadd2);
            	    }else if( pointno==2){
            	        ipb[j]=ip_value[j].substring(pointadd1,pointadd2);
            	    }else if( pointno==3){
                        ipc[j]=ip_value[j].substring(pointadd1,pointadd2);
            	    }else{
                        /* do nothing*/
            	    }
            	}else{
            	    flag="error";
            	}
                pointadd1=pointadd2+1;
            }else{
                /* do nothing */
            }
        }
        pointadd2=ip_value[j].length;
        ipd[j]=ip_value[j].substring(pointadd1,pointadd2);
    }
    
    for( var k=1; k<254; k++){
        /* host ip included NG */
        if(ipd[2]==ipd[0] && ipa[2]==ipa[0] && ipb[2]==ipb[0] && ipc[2]==ipc[0] ){
            return false;
        }else{
            /* do nothing */
        }
        
        /* if equal [1] == [2] */
        if((ipa[1]==ipa[2]) && (ipb[1]==ipb[2]) && (ipc[1]==ipc[2]) && (ipd[1]==ipd[2])){
            break;
        }else{
            /* do nothing */
        }
        
        /* address decrement */
        if( --ipd[2] < "0"){
            ipd[2]="255";
            if(--ipc[2] < "0"){
                ipc[2]="255";
                if( --ipb[2] < "0" ){
                    ipb[2]="255";
                    if( --ipa[2] < "0"){
                        //flag="error";
                        break;
                    }else{
                        /* do nothing */
                    }
                }else{
                    /* do nothing */
                }
            }else{
                /* do nothing */
            }
        }else{
            /* do nothing */
        }
    }
    if (k > 253) return false; /* dhcp number more than 253 */
    return true;
}

/*=======================================================================
; Comment: Java Script for checking DHCP IP Address
           DHCP Start IP and DHCP End IP range is include the Client IP Address
; IN : Client IP Addres, DHCP Start IP Address, DHCP End IP Address
; OUT: true:DHCP IP Address Setting is OK, false:DHCP IP Address Setting is not between DHCP Start IP and DHCP End IP
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/03
; Original Reference: KME project
;========================================================================*/
function CheckDHCPRangeIn(lan_ip, start_ip, end_ip)
{
    var pointadd1=0;
    var pointadd2=0;
    var pointno=0;
    var ip_value= new Array();
    var ipa= new Array();
    var ipb= new Array();
    var ipc= new Array();
    var ipd= new Array();
    
    ip_value[0]=lan_ip.value;
    ip_value[1]=start_ip.value;
    ip_value[2]=end_ip.value;
    
    for(var j=0; j<3; j++){
        pointadd1=0;
        pointadd2=0;
        pointno=0;
        for(var i=0; i<ip_value[j].length; i++){
            if(ip_value[j].substring(i,i+1)=="."){
                pointno++;
                pointadd2=i;
                if(ip_value[j].substring(pointadd1,pointadd2)>=0 && ip_value[j].substring(pointadd1,pointadd2)<=255){
                    if( pointno==1){
                        ipa[j]=ip_value[j].substring(pointadd1,pointadd2);
                    }else if( pointno==2){
                        ipb[j]=ip_value[j].substring(pointadd1,pointadd2);
                    }else if( pointno==3){
                        ipc[j]=ip_value[j].substring(pointadd1,pointadd2);
                    }else{
                        /* do nothing */
                    }
                }else{
                    flag="error";
                }
                pointadd1=pointadd2+1;
            }else{
                /* do nothing */
            }
        }
        pointadd2=ip_value[j].length;
        ipd[j]=ip_value[j].substring(pointadd1,pointadd2);
    }
   
    for( var k=1; k<254; k++){
        /* host ip included NG */
        if(ipd[2]==ipd[0] && ipa[2]==ipa[0] && ipb[2]==ipb[0] && ipc[2]==ipc[0] ){
            return true;
        }else{
            /* do nothing */
        }
        
        /* if equal [1] == [2] */
        if((ipa[1]==ipa[2]) && (ipb[1]==ipb[2]) && (ipc[1]==ipc[2]) && (ipd[1]==ipd[2])){
            break;
        }else{
            /* do nothing */
        }
        
        /* address decrement */
        if( --ipd[2] <"0"){
            ipd[2]="255";
            if(--ipc[2] <"0"){
                ipc[2]="255";
                if( --ipb[2] <"0" ){
                    ipb[2]="255";
                    if( --ipa[2] <"0"){
                        flag="error";
                        break;
                    }else{
                        /* do nothing */
                    }
                }else{
                       /* do nothing */
                }
            }else{
                /* do nothing */
            }
        }else{
            /* do nothing */
        }
    }
    return false;
}

/*=======================================================================
; Comment: Java Script for LAN Setting
; IN : HTML Form
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/01
; Original Reference: KME project
;========================================================================*/
function CheckLANSetting(form)
{
    if(CheckIPAddress(form.lan_ipaddr1, 1, 0) == false){
        alert("Invalid IP Address ( "+form.lan_ipaddr1.value+" ).");
        form.lan_ipaddr1.value = "";
        return false;
    }else{
        /* do nothing */
    }
    
    var nNetMaskBits = ReturnSubnetBit(form.lan_netmask1);
    if(nNetMaskBits == 0){
        alert("Invalid Netmask Address ( "+form.lan_netmask1.value+" ).");
        form.lan_netmask1.value = "";
        return false;
    }else{
        /* do nothing */
    }
    
    if(form.dhcpd_enable[1].selected){
        if((CheckIPAddress(form.dhcpd_startip, 1, 0) == true) &&
           (CheckIPAddress(form.dhcpd_endip, 1, 0) == true) &&
           (CheckBothAddrIsSameNet(form.dhcpd_startip, form.dhcpd_endip, form.lan_netmask1) ==true ) &&
           (CheckBothAddrIsSameNet(form.lan_ipaddr1, form.dhcpd_startip, form.lan_netmask1) ==true ) &&
           (CheckBothAddrIsSameNet(form.lan_ipaddr1, form.dhcpd_endip, form.lan_netmask1) ==true ) &&
           (CheckAddrIsNet(form.dhcpd_startip, nNetMaskBits) == false ) &&
           (CheckAddrIsNet(form.dhcpd_endip, nNetMaskBits) == false ) &&
           (CheckAddrIsBoard(form.dhcpd_startip, nNetMaskBits) == false ) &&
           (CheckAddrIsBoard(form.dhcpd_endip, nNetMaskBits) == false ) &&
           (CheckDHCPRangeOut(form.lan_ipaddr1, form.dhcpd_startip, form.dhcpd_endip) == true)){
            /* do nothing */
        }else{
            alert("Invalid DHCP Setting ( "+form.dhcpd_startip.value+" - "+form.dhcpd_endip.value+" ).");
            return false;
        }
    }else{
        /* do nothing */
    }
    
    for(var i = 1; i < 33; i++){
        if(eval("form.dhcpd_flg"+i+"[1]").selected == true){
            var ip_s = eval("form.dhcpd_ipa"+i);
            if(CheckIPAddress(ip_s, 1, 0) == false){
                alert(i+" Invalid DHCP IP Addresss.");
                ip_s.value = "";
                return false;
            }else{
                /* do nothing */
            }
            if(!CheckDHCPRangeIn(ip_s, form.dhcpd_startip, form.dhcpd_endip)){
                alert(i+" IP Address is not DHCP Address Range.");
                return false;
            }else{
                /* do nothing */
            }
            var mac_s = eval("form.dhcpd_mac"+i);
            if(CheckMAC(mac_s, 1, 0) == false){
                alert(i+" Invalid MAC Address.");
                mac_s.value = "";
                return false;
            }else{
                /* do nothing */
            }
            if(i<32){
                for(var j=i+1;j<33;j++){
                    if(eval("form.dhcpd_flg"+j+"[0]").selected == true){
                        continue;
                    }else{
                        /* do nothing */
                    }
                    var ip_s2 = eval("form.dhcpd_ipa"+j);
                    if(ip_s.value == ip_s2.value){
                        alert(i+" and "+j+" both LAN IP Address are the same.");
                        return false;
                    }else{
                        /* do nothing */
                    }
                    var mac_s2 = eval("form.dhcpd_mac"+j);
                    if(mac_s.value == mac_s2.value){
                        alert(i+" and "+j+" both MAC Address are the same.");
                        return false;
                    }else{
                        /* do nothing */
                    }
                }
            }else{
                /* do nothing */
            }
        }
    }
    return true;
}

/*=======================================================================
; Comment: Java Script for Basic LAN Setting
; IN : HTML Form
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckBasicLANSetting(form)
{
    if(CheckIPAddress(form.lan_ipaddr1, 1, 0) == false){
        alert("Invalid IP Address ( "+form.lan_ipaddr1.value+" ).");
        form.lan_ipaddr1.value = "";
        return false;
    }else{
        /* do nothing */
    }
    
    var nNetMaskBits = ReturnSubnetBit(form.lan_netmask1);
    if(nNetMaskBits == 0){
        alert("Invalid Netmask Address ( "+form.lan_netmask1.value+" ).");
        form.lan_netmask1.value = "";
        return false;
    }else{
        /* do nothing */
    }
    
    if(form.dhcpd_enable[0].checked){
        if((CheckIPAddress(form.dhcpd_startip, 1, 0) == true) &&
           (CheckIPAddress(form.dhcpd_endip, 1, 0) == true) &&
           (CheckBothAddrIsSameNet(form.dhcpd_startip, form.dhcpd_endip, form.lan_netmask1) ==true ) &&
           (CheckBothAddrIsSameNet(form.lan_ipaddr1, form.dhcpd_startip, form.lan_netmask1) ==true ) &&
           (CheckBothAddrIsSameNet(form.lan_ipaddr1, form.dhcpd_endip, form.lan_netmask1) ==true ) &&
           (CheckAddrIsNet(form.dhcpd_startip, nNetMaskBits) == false ) &&
           (CheckAddrIsNet(form.dhcpd_endip, nNetMaskBits) == false ) &&
           (CheckAddrIsBoard(form.dhcpd_startip, nNetMaskBits) == false ) &&
           (CheckAddrIsBoard(form.dhcpd_endip, nNetMaskBits) == false ) &&
           (CheckDHCPRangeOut(form.lan_ipaddr1, form.dhcpd_startip, form.dhcpd_endip) == true)){
            /* do nothing */
        }else{
            alert("Invalid DHCP Setting ( "+form.dhcpd_startip.value+" - "+form.dhcpd_endip.value+" ).");
            return false;
        }
    }else{
        /* do nothing */
    }
}