/*=======================================================================
; Comment: Java Script for checking route source IP Address in multisession 
; IN : IP Address, Error Message Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/09
; Original Reference: KME project
;========================================================================*/
function CheckSourceIP(ip_str, errmes)
{
    var ip_str_s = Trim(ip_str.value);
    ip_str.value = ip_str_s;
    if(ip_str_s.match(/^0{1,3}\.0{1,3}\.0{1,3}\.0{1,3}$/) || ip_str_s.match(/^255\.255\.255\.255$/)){
        if(errmes == 1){
            alert("Invalid IP Address ( "+ip_str_s+" ).");
            ip_str.value = "";
        }else{
            /* do nothing */
        }
        return false;
    }else{
        /* do nothing */
    }
    if(ip_str_s == "" || ip_str_s == "*"){
        /* do nothing */
    }else if(ip_str_s.match(/^([0-9\.\-/]+,){0,3}([0-9\.\-/]+)$/)){
        var ip_str_tmp = ip_str_s;
        var From = new Array(4);
        var To = new Array(4);
        while(1){
            index = ip_str_tmp.indexOf(",");
            if(index == -1){
                ip_s = ip_str_tmp.slice(0);
                ip_str_tmp = "";
                if(ip_s.length == 0){
                    break;
                }else{
                    /* do nothing */
                }
            }else{
                ip_s = ip_str_tmp.substring(0,index);
                ip_str_tmp = ip_str_tmp.slice(index+1);
            }
            if(ip_s.match(/^((\d|[01]?\d\d|2[0-4]\d|25[0-5])\.){3}(\d|[01]?\d\d|2[0-4]\d|25[0-5])$/)){
                /* do nothing */
            }else if(ip_s.match(/^((\d|[01]?\d\d|2[0-4]\d|25[0-5])\.){3}(\d|[01]?\d\d|2[0-4]\d|25[0-5])\/([12]?\d|3[0-2])$/)){
            	/* do nothing */
            }else if(ip_s.match(/^((\d|[01]?\d\d|2[0-4]\d|25[0-5])\.){3}(\d|[01]?\d\d|2[0-4]\d|25[0-5])-((\d|[01]?\d\d|2[0-4]\d|25[0-5])\.){3}(\d|[01]?\d\d|2[0-4]\d|25[0-5])$/)){
                index = ip_s.indexOf(".");
                From[0] = ip_s.substring(0,index) - 0;
                ip_s = ip_s.slice(index+1);
                index = ip_s.indexOf(".");
                From[1] = ip_s.substring(0,index) - 0;
                ip_s = ip_s.slice(index+1);
                index = ip_s.indexOf(".");
                From[2] = ip_s.substring(0,index) - 0;
                ip_s = ip_s.slice(index+1);
                index = ip_s.indexOf("-");
                From[3] = ip_s.substring(0,index) - 0;
                ip_s = ip_s.slice(index+1);
                
                index = ip_s.indexOf(".");
                To[0] = ip_s.substring(0,index) - 0;
                ip_s = ip_s.slice(index+1);
                index = ip_s.indexOf(".");
                To[1] = ip_s.substring(0,index) - 0;
                ip_s = ip_s.slice(index+1);
                index = ip_s.indexOf(".");
                To[2] = ip_s.substring(0,index) - 0;
                ip_s = ip_s.slice(index+1);
                To[3] = ip_s.slice(0) - 0;
                
                for(var i=0;i<4;i++){
                    if(From[i] < To[i]){
                        break;
                    }else if(From[i] > To[i]){
                        if(errmes == 1){
                            alert("Invalid Source IP Address Range ( "+ip_str_s+" ).");
                            ip_str.value = "";
                        }else{
                            /* do nothing */
                        }
                        return false;
                    }else if(i == 3){
                        if(errmes == 1){
                            alert("Equal Source IP Address Range ( "+ip_str_s+" ).");
                            ip_str.value = "";
                        }else{
                            /* do nothing */
                        }
                        return false;
                    }
                }
            }else{
                if(errmes == 1){
                    alert("Invalid Source IP Address ( "+ip_str_s+" ).");
                    ip_str.value = "";
                }else{
                    /* do nothing */
                }
                return false;
            }
        }
    }else{
        if(errmes == 1){
            alert("Invalid Source IP Address ( "+ip_str_s+" )."); 
            ip_str.value = ""; 
        }else{
            /* do nothing */
        }
        return false;
    }
    return true;
}

/*=======================================================================
; Comment: Java Script for checking route Host IP Address in multisession 
; IN : IP Address, Error Message Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/09
; Original Reference: KME project
;========================================================================*/
function CheckHostIP(ip_str, errmes)
{
    var ip_str_s = Trim(ip_str.value);
    ip_str.value = ip_str_s;
    if(ip_str_s.length == 0){
        return true;
    }else{
        if(!CheckSourceIP(ip_str, 0)){
            if(ip_str_s.match(/^0{1,3}\.0{1,3}\.0{1,3}\.0{1,3}$/) || ip_str_s.match(/^255\.255\.255\.255$/)){
                if(errmes == 1){
                    alert("Invalid Destination IP Address ( "+ip_str_s+" ).");
                    ip_str.value = "";
                }else{
                    /* do nothing */
                }
                return false;
            }else{
                if(ip_str_s.match(/^((([A-Za-z0-9]+-*[A-Za-z0-9]+)|([A-Za-z0-9]))\.)+[A-Za-z0-9]+$/)){
                    /* do nothing */
                }else if(ip_str_s.match(/^(\.(([A-Za-z0-9]+-*[A-Za-z0-9]+)|([A-Za-z0-9])))*\.[A-Za-z0-9]+$/)){
                    /* do nothing */
                }else if(ip_str_s.match(/^((([A-Za-z0-9]+-*[A-Za-z0-9]+)|([A-Za-z0-9]))\.)+\*\.((([A-Za-z0-9]+-*[A-Za-z0-9]+)|([A-Za-z0-9]))\.)*[A-Za-z0-9]+$/)){
                    /* do nothing */
                }else{
                    if(errmes == 1){
                        alert("Invalid Destination IP Address ( "+ip_str_s+" ).");
                        ip_str.value = "";
                    }else{
                        /* do nothing */
                    }
                    return false;
                }
            }        
        }else{
            /* do nothing */
        } 
        return true;
    }
}

/*=======================================================================
; Comment: Java Script for checking route Port in multisession 
; IN : IP Address, Error Message Flag
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/09
; Original Reference: KME project
;========================================================================*/
function CheckPort(port_str, errmes)
{
    var port_str_s = Trim(port_str.value);
    port_str.value = port_str_s;
    if(port_str_s == ""){
        alert("Please Input Port Number.");
        return false;
    }else if(port_str_s.match(/^(([1-9]\d{0,3}|[1-5]\d{4}|6[0-4]\d{3}|65[0-4]\d{2}|655[0-2]\d|6553[0-5])(\-([1-9]\d{0,3}|[1-5]\d{4}|6[0-4]\d{3}|65[0-4]\d{2}|655[0-2]\d|6553[0-5])){0,1},){0,3}([1-9]\d{0,3}|[1-5]\d{4}|6[0-4]\d{3}|65[0-4]\d{2}|655[0-2]\d|6553[0-5])(\-([1-9]\d{0,3}|[1-5]\d{4}|6[0-4]\d{3}|65[0-4]\d{2}|655[0-2]\d|6553[0-5])){0,1}$/)){
        var port_str_tmp = port_str_s;
        while(1){
            index = port_str_tmp.indexOf(",");
            if(index == -1){
                port_s = port_str_tmp.slice(0);
                port_str_tmp = "";
                if(port_s.length == 0){
                    break;
                }else{
                    /* do nothing  */
                }
            }else{
                port_s = port_str_tmp.substring(0,index);
                port_str_tmp = port_str_tmp.slice(index+1);
            }
            
            index = port_s.indexOf("-");
            if(index == -1){
                continue;
            }else{
                /* do nothing  */
            }
            From = port_s.substring(0,index) - 0;
            To = port_s.slice(index+1) - 0;
            if(From >= To){
                if(errmes == 1){
                    alert("Invalid Port Range ( "+port_str_s+" ).");
                    port_str.value = "";
                }else{
                    /* do nothing */
                }
                return false;
            }
        }
    }else if(port_str_s.match(/^\*$/)){
        /* do nothing */
    }else{
        if(errmes == 1){
            alert("Invalid Port ( "+port_str_s+" ).");
            port_str.value = "";
        }else{
            /* do nothing */
        }
        return false;
    }
    return true;
}

/*=======================================================================
; Comment: Java Script for multisession HTML check "select" is right or wrong
; IN : Form Type
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/09
; Original Reference: KME project
;========================================================================*/
function CheckSelection(form)
{
    var main_p = form.session0_select.value;
    
    if(main_p == 0){
        if(form.session1_select[0].selected != true || form.session2_select[0].selected != true || form.session3_select[0].selected != true){
            alert("Please Select Main Session WAN TYPE");
            return false;
        }else{
            /* do nothing */
        }
    }else{
        var wan_t = eval("form.wan"+main_p+"_is_static_DHCP");
        if(wan_t.value == 1){
            if(form.session1_select[0].selected != true || form.session2_select[0].selected != true || form.session3_select[0].selected != true){
                alert("Please Select Main Session WAN TYPE To PPPoE");
                return false;
            }else{
                /* do nothing */
            }
        }else{
             /* do nothing */
        }
        var wan_t = eval("form.wan"+main_p+"_is_PPPoELan");
        if(wan_t.value == 1){
            if(form.session1_select[0].selected != true){
                alert("Please Select Main Session WAN TYPE To PPPoE");
                return false;
            }else{
                 /* do nothing */
            }
        }else{
             /* do nothing */
        }
    }
    return true;
}

/*=======================================================================
; Comment: Java Script for checking multisession HTML
; IN : Form Type
; OUT: true:success, false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/09
; Original Reference: KME project
;========================================================================*/
function CheckMultiSession(form)
{
    return true;   //GN-B46B didn't have multisession
    
    if(false == CheckSelection(form)){
        return false;
    }else{
        /* do nothing */
    }

    for(var i = 2; i < 4; i++){
        if(eval("form.session"+i+"_select[0]").selected == true){
            continue;
        }else{
            var ip_s = eval("form.session"+i+"_route_source_ip");
            if(Trim(ip_s.value) == ""){
                ip_s.value = "";
            }else if(CheckSourceIP(ip_s, 0) == false){
                var num = i-1;
                alert("Invlaid Sub "+num+" Source IP Address ( "+ip_s.value+" ).");
                ip_s.value = "";
                return false;
            }else{
                /* do nothing */
            }
            var iphost_s = eval("form.session"+i+"_route_dest_ip");
            if(Trim(iphost_s.value) == ""){
                iphost_s.value = "";
            }else if(CheckHostIP(iphost_s, 0) == false){
                var num = i-1;
                alert("Invlaid Sub "+num+" Destination IP Address ( "+iphost_s.value+")");
                iphost_s.value = "";
                return false;
            }else{
                /* do nothing */
            }
            var port_s = eval("form.session"+i+"_route_port");
            if(Trim(port_s.value) == ""){
            	var num = i-1;
                alert("Please Input Sub "+num+" Port Number.");
                return false;
            }else if(CheckPort(port_s, 0) == false){
                var num = i-1;
                alert("Invlaid Sub "+num+" Port ( "+port_s.value+" ).");
                port_s.value = "";
                return false;
            }else{
                /* do nothing */
            }
        }
    }
    return true;
}
