/*=======================================================================
; Comment: Java Script for checking Wireless SSID
; IN : SSID String
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckSSID(rf_ssid)
{
    var ss = new String(rf_ssid.value);
    var len = ss.length;
    var flag = false;
    
    if(len>32){
        alert("SSID Data Excess 32 Length");
        return false;
    }else{
        flag = true;
        for(var i=0;i<len;i++){
            /* AscCode 0x20 to 0x7e Accept */
            if(ss.charAt(i)>=' ' && ss.charAt(i)<='~'){
                /* do nothing */
            }else{
                flag = false;
                break;
            }
        }
        if(len ==0){
            flag = false;
        }else{
            /* do nothing */
        }
        if(flag == false){
            alert("Invalid SSID Input.");
        }else{
            /* do nothing */
        }
        return flag;
    }
}

/*=======================================================================
; Comment: Java Script for checking Wireless WEP KEY
; IN : WEP KEY String, Form Type, Error Message Flag
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckWepKey(key, form, err_mess)
{
    var key_select = form.rf_key_select.value;
    var wep_type = form.rf_wep.value;
    var chk_key_No;
    var key_len = key.value.length;
    
    if(key.name.match(/[1]$/)){
        chk_key_No = 1;
    }else if(key.name.match(/[2]$/)){
        chk_key_No = 2;
    }else if(key.name.match(/[3]$/)){
        chk_key_No = 3;
    }else if(key.name.match(/[4]$/)){
        chk_key_No = 4;
    }else{
        /* do nothing */
    }
    
    //if(chk_key_No == key_select){
    if(1){
        switch(wep_type){
        case '0':
             if(key.value == "**********"
                || key.value == "**************************"
                || key.value == "********************************"
                || key_len == 0
                || (key_len == 14 && key.value.match(/^([A-Za-z0-9]{2}\-){4}[A-Za-z0-9]{2}$/))
                || (key_len == 38 && key.value.match(/^([A-Za-z0-9]{2}\-){12}[A-Za-z0-9]{2}$/))
                || (key_len == 47 && key.value.match(/^([A-Za-z0-9]{2}\-){15}[A-Za-z0-9]{2}$/))){
                 return true;
             }else{
                 /* do nothing */
             }
             break;
        case '1':
             if(key.value == "**********"
                || ((key_len ==0) && (chk_key_No != key_select))
                || (key_len == 14 && key.value.match(/^([A-Za-z0-9]{2}\-){4}[A-Za-z0-9]{2}$/))){
                 return true;
             }else{
                 /* do nothing */
             }
             break;
        case '2':
             if(key.value == "**************************"
                || ((key_len ==0) && (chk_key_No != key_select))
                || (key_len == 38 && key.value.match(/^([A-Za-z0-9]{2}\-){12}[A-Za-z0-9]{2}$/))){
                 return true;
             }else{
                 /* do nothing */
             }
             break;
        case '3':
            if(key.value == "********************************"
                || ((key_len ==0) && (chk_key_No != key_select))
                || (key_len == 47 && key.value.match(/^([A-Za-z0-9]{2}\-){15}[A-Za-z0-9]{2}$/))){
                 return true;
             }else{
                 /* do nothing */
             }
             break;
        }
    }else{
        if(key.value == "**********"
           || key.value == "**************************"
           || key.value == "********************************"
           || key_len == 0
           || (key_len == 14 && key.value.match(/^([A-Za-z0-9]{2}\-){4}[A-Za-z0-9]{2}$/))
           || (key_len == 38 && key.value.match(/^([A-Za-z0-9]{2}\-){12}[A-Za-z0-9]{2}$/))
           || (key_len == 47 && key.value.match(/^([A-Za-z0-9]{2}\-){15}[A-Za-z0-9]{2}$/))){
            return true;
        }else{
            /* do nothing */
        }
    }
    if(err_mess){
        alert("Invalid WEP KEY ( "+key.value+" ).");
        key.value = "";
    }else{
        /* do nothing */
    }
    return false;
    
}

/*=======================================================================
; Comment: Java Script for checking Wireless WEP KEY
; IN : WEP KEY String, Form Type, Error Message Flag
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckWDSWepKey(key, form, err_mess)
{
    var key_select = form.wds_wep_key_select.value;
    var wep_type = form.wds_wep_size.value;
    var chk_key_No;
    var key_len = key.value.length;
    
    if(key.name.match(/[1]$/)){
        chk_key_No = 1;
    }else if(key.name.match(/[2]$/)){
        chk_key_No = 2;
    }else if(key.name.match(/[3]$/)){
        chk_key_No = 3;
    }else if(key.name.match(/[4]$/)){
        chk_key_No = 4;
    }else{
        /* do nothing */
    }
    
    //if(chk_key_No == key_select){
    if(1){
        switch(wep_type){
        case '0':
             if(key.value == "**********"
                || key.value == "**************************"
                || key.value == "********************************"
                || key_len == 0
                || (key_len == 14 && key.value.match(/^([A-Za-z0-9]{2}\-){4}[A-Za-z0-9]{2}$/))
                || (key_len == 38 && key.value.match(/^([A-Za-z0-9]{2}\-){12}[A-Za-z0-9]{2}$/))
                || (key_len == 47 && key.value.match(/^([A-Za-z0-9]{2}\-){15}[A-Za-z0-9]{2}$/))){
                 return true;
             }else{
                 /* do nothing */
             }
             break;
        case '1':
             if(key.value == "**********"
                || ((key_len ==0) && (chk_key_No != key_select))
                || (key_len == 14 && key.value.match(/^([A-Za-z0-9]{2}\-){4}[A-Za-z0-9]{2}$/))){
                 return true;
             }else{
                 /* do nothing */
             }
             break;
        case '2':
             if(key.value == "**************************"
                || ((key_len ==0) && (chk_key_No != key_select))
                || (key_len == 38 && key.value.match(/^([A-Za-z0-9]{2}\-){12}[A-Za-z0-9]{2}$/))){
                 return true;
             }else{
                 /* do nothing */
             }
             break;
        case '3':
            if(key.value == "********************************"
                || ((key_len ==0) && (chk_key_No != key_select))
                || (key_len == 47 && key.value.match(/^([A-Za-z0-9]{2}\-){15}[A-Za-z0-9]{2}$/))){
                 return true;
             }else{
                 /* do nothing */
             }
             break;
        }
    }else{
        if(key.value == "**********"
           || key.value == "**************************"
           || key.value == "********************************"
           || key_len == 0
           || (key_len == 14 && key.value.match(/^([A-Za-z0-9]{2}\-){4}[A-Za-z0-9]{2}$/))
           || (key_len == 38 && key.value.match(/^([A-Za-z0-9]{2}\-){12}[A-Za-z0-9]{2}$/))
           || (key_len == 47 && key.value.match(/^([A-Za-z0-9]{2}\-){15}[A-Za-z0-9]{2}$/))){
            return true;
        }else{
            /* do nothing */
        }
    }
    if(err_mess){
        alert("Invalid WEP KEY ( "+key.value+" ).");
        key.value = "";
    }else{
        /* do nothing */
    }
    return false;
    
}

/*=======================================================================
; Comment: Java Script for checking Wireless 1
; IN : Form Type
; OUT: true:success false:error
; Important algorithm:

/*=======================================================================
; Comment: Java Script for checking Wireless 1
; IN : Form Type
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/11
; Original Reference: KME project
;========================================================================*/
function CheckWireless(form)
{
    var flag=false;
    if(CheckSSID(form.rf_ssid)){
        flag=true;
    }else{
        /* do nothing */
    }

    /* check Encryption */
    if(form.rf_enc.value == "0") // disable
    {
	if (form.rf_auth.value == "3") 
	{ // 802.1X
	    if (!CheckIPAddress(form.rf_8021x_ip,1,1))
	    {
		flag = false;
   	    }
	    if (!CheckPort(form.rf_8021x_port,1,1))
	    {
		flag = false;
	    }
	} 
    }else if (form.rf_enc.value == "1") // WEP
    { 
            for(var i=1;i<5;i++)
	    {
                var key_s = eval("form.rf_key_hex"+i);
                if(!CheckWepKey(key_s, form, 0))
		{
                    alert("Invalid KEY Input in ( "+i+" ).");
                    flag=false;
                    break;
            	}else
		{
                    /* do nothing */
            	}
            }
	if (form.rf_auth.value == "3") 
	{ // 802.1X
	    if (!CheckIPAddress(form.rf_8021x_ip,1,1))
	    {
		flag = false;
   	    }
	    if (!CheckPort(form.rf_8021x_port,1,1))
	    {
		flag = false;
	    }
	} 
    }else if (form.rf_enc.value == "2") // WPA
    { 
	if (form.rf_wpa_auth.value == "0") // RADIUS
	{ 
		if (!CheckIPAddress(form.rf_8021x_ip,1,1))
		{
			flag = false;
		}
		if (!CheckPort(form.rf_8021x_port,1,1))
		{
			flag = false;
		}
	}
	else if (form.rf_wpa_auth.value == "1") // PSK
	{
		if (form.rf_wpa_pskformat.value=="1")
		{
			if (form.rf_wpa_pskvalue.value.match(/^[A-Fa-f0-9]{64}/) ==null )
			{
				alert("Invalid Pre-shared Key");
				flag = false;
			}
		}else if (form.rf_wpa_pskformat.value == "0")
		{
			if (form.rf_wpa_pskvalue.value.length<8 || form.rf_wpa_pskvalue.value.length>63)
			{
				alert("Invalid Pre-shared Key");
				flag = false;
			}
		}
	}
    }else 
    {
	flag = false;
    }

    if (flag == false) {
        return flag;
    } else {
        /* do nothing */
    }

    if ((form.rf_auth.selectedIndex == "2") && (szHWInfo=="Atheros AR5K 802.11 Wireless LAN")) {
        flag=true;
    } else if ((form.rf_auth.selectedIndex == "3") && (szHWInfo=="Intersil Prism 802.11 Wireless LAN")) {
        flag=true;
    } else if ( (frm.rf_enc.selectedIndex == "0") && (frm.rf_auth.value != "0" && frm.rf_auth.value != "3") ) {
        alert("Authenticate type should configure to \"open system\" or \"802.1X\" while WEP disable"); 
        flag=false;
    } else {
        /* do nothing */
    }

    return flag;
}


/*=======================================================================
; Comment: Java Script for checking Wireless MAC
; IN : Form Type
; OUT: true:success false:error
; Important algorithm:
; Author:Jason Lan
; Time: 2003/04/14
; Original Reference: KME project
;========================================================================*/
function CheckWirelessMac(form)
{
    if(form.rf_mac_enable[1].checked){
        for(var i = 1; i < 33; i++){
            if(CheckMAC(eval("form.rf_mac"+i), 0, 0) == false){
                alert("MAC "+i+" Invalid MAC Address( "+eval("form.rf_mac"+i).value+" ).");
                eval("form.rf_mac"+i).value = "";
                return false;
            }else{
                /* do nothing */
            }
        }
    }else{
        /* do nothing */
    }
    return true;
}
